var JavaBoolean = Java.type("java.lang.Boolean");
var Class = Java.type("java.lang.Class");
var JavaObject = Java.type("java.lang.Object");
var JavaString = Java.type("java.lang.String");
var Modifier = Java.type("java.lang.reflect.Modifier");
var Arrays = Java.type("java.util.Arrays");
var StringJoiner = Java.type("java.util.StringJoiner");
var PacketEvent = Java.type("net.ccbluex.liquidbounce.event.PacketEvent");
var PacketImpl = Java.type("net.ccbluex.liquidbounce.injection.backend.PacketImpl");
var Remapper = Java.type("net.ccbluex.liquidbounce.script.remapper.Remapper");
var BoolValue = Java.type("net.ccbluex.liquidbounce.value.BoolValue");
var INetHandler = Java.type("net.minecraft.network.INetHandler");
var Packet = Java.type("net.minecraft.network.Packet");
var CPacketPlayer = Java.type("net.minecraft.network.play.client.CPacketPlayer");
var SPacketEntity = Java.type("net.minecraft.network.play.server.SPacketEntity");
// CPacketAnimation
// CPacketChatMessage
// CPacketClickWindow
// CPacketClientSettings
// CPacketClientStatus
// CPacketCloseWindow
// CPacketConfirmTeleport
// CPacketConfirmTransaction
// CPacketCreativeInventoryAction
// CPacketCustomPayload
// CPacketEnchantItem
// CPacketEntityAction
// CPacketHeldItemChange
// CPacketInput
// CPacketKeepAlive
// CPacketPlaceRecipe
// CPacketPlayer$Position
// CPacketPlayer$PositionRotation
// CPacketPlayer$Rotation
// CPacketPlayer
// CPacketPlayerAbilities
// CPacketPlayerDigging
// CPacketPlayerTryUseItem
// CPacketPlayerTryUseItemOnBlock
// CPacketRecipeInfo
// CPacketResourcePackStatus
// CPacketSeenAdvancements
// CPacketSpectate
// CPacketSteerBoat
// CPacketTabComplete
// CPacketUpdateSign
// CPacketUseEntity
// CPacketVehicleMove
// SPacketAdvancementInfo
// SPacketAnimation
// SPacketBlockAction
// SPacketBlockBreakAnim
// SPacketBlockChange
// SPacketCamera
// SPacketChangeGameState
// SPacketChat
// SPacketChunkData
// SPacketCloseWindow
// SPacketCollectItem
// SPacketCombatEvent
// SPacketConfirmTransaction
// SPacketCooldown
// SPacketCustomPayload
// SPacketCustomSound
// SPacketDestroyEntities
// SPacketDisconnect
// SPacketDisplayObjective
// SPacketEffect
// SPacketEntity$S15PacketEntityRelMove
// SPacketEntity$S16PacketEntityLook
// SPacketEntity$S17PacketEntityLookMove
// SPacketEntity
// SPacketEntityAttach
// SPacketEntityEffect
// SPacketEntityEquipment
// SPacketEntityHeadLook
// SPacketEntityMetadata
// SPacketEntityProperties
// SPacketEntityStatus
// SPacketEntityTeleport
// SPacketEntityVelocity
// SPacketExplosion
// SPacketHeldItemChange
// SPacketJoinGame
// SPacketKeepAlive
// SPacketMaps
// SPacketMoveVehicle
// SPacketMultiBlockChange
// SPacketOpenWindow
// SPacketParticles
// SPacketPlaceGhostRecipe
// SPacketPlayerAbilities
// SPacketPlayerListHeaderFooter
// SPacketPlayerListItem
// SPacketPlayerPosLook
// SPacketRecipeBook
// SPacketRemoveEntityEffect
// SPacketResourcePackSend
// SPacketRespawn
// SPacketScoreboardObjective
// SPacketSelectAdvancementsTab
// SPacketServerDifficulty
// SPacketSetExperience
// SPacketSetPassengers
// SPacketSetSlot
// SPacketSignEditorOpen
// SPacketSoundEffect
// SPacketSpawnExperienceOrb
// SPacketSpawnGlobalEntity
// SPacketSpawnMob
// SPacketSpawnObject
// SPacketSpawnPainting
// SPacketSpawnPlayer
// SPacketSpawnPosition
// SPacketStatistics
// SPacketTabComplete
// SPacketTeams
// SPacketTimeUpdate
// SPacketTitle
// SPacketUnloadChunk
// SPacketUpdateBossInfo
// SPacketUpdateHealth
// SPacketUpdateScore
// SPacketUpdateTileEntity
// SPacketUseBed
// SPacketWindowItems
// SPacketWindowProperty
// SPacketWorldBorder
// LCPacketEncryptionResponse
// LCPacketLoginStart
// LSPacketDisconnect
// LSPacketEnableCompression
// LSPacketEncryptionRequest
// LSPacketLoginSuccess
var scriptName = "PacketDebug";
var scriptVersion = 0.1;
var scriptAuthor = "mumy++";
var PacketDebug = /** @class */ (function () {
    function PacketDebug() {
        var _this = this;
        this.setting = {
            boolean: function (name, def, object) {
                if (object === void 0) { object = {}; }
                return new _AdaptedValue(new (Java.extend(BoolValue, object))(name, def));
            }
        };
        this.packetList = ["CPacketAnimation", "CPacketChatMessage", "CPacketClickWindow", "CPacketClientSettings", "CPacketClientStatus", "CPacketCloseWindow", "CPacketConfirmTeleport", "CPacketConfirmTransaction", "CPacketCreativeInventoryAction", "CPacketCustomPayload", "CPacketEnchantItem", "CPacketEntityAction", "CPacketHeldItemChange", "CPacketInput", "CPacketKeepAlive", "CPacketPlaceRecipe", "CPacketPlayer$Position", "CPacketPlayer$PositionRotation", "CPacketPlayer$Rotation", "CPacketPlayer", "CPacketPlayerAbilities", "CPacketPlayerDigging", "CPacketPlayerTryUseItem", "CPacketPlayerTryUseItemOnBlock", "CPacketRecipeInfo", "CPacketResourcePackStatus", "CPacketSeenAdvancements", "CPacketSpectate", "CPacketSteerBoat", "CPacketTabComplete", "CPacketUpdateSign", "CPacketUseEntity", "CPacketVehicleMove", "SPacketAdvancementInfo", "SPacketAnimation", "SPacketBlockAction", "SPacketBlockBreakAnim", "SPacketBlockChange", "SPacketCamera", "SPacketChangeGameState", "SPacketChat", "SPacketChunkData", "SPacketCloseWindow", "SPacketCollectItem", "SPacketCombatEvent", "SPacketConfirmTransaction", "SPacketCooldown", "SPacketCustomPayload", "SPacketCustomSound", "SPacketDestroyEntities", "SPacketDisconnect", "SPacketDisplayObjective", "SPacketEffect", "SPacketEntity$S15PacketEntityRelMove", "SPacketEntity$S16PacketEntityLook", "SPacketEntity$S17PacketEntityLookMove", "SPacketEntity", "SPacketEntityAttach", "SPacketEntityEffect", "SPacketEntityEquipment", "SPacketEntityHeadLook", "SPacketEntityMetadata", "SPacketEntityProperties", "SPacketEntityStatus", "SPacketEntityTeleport", "SPacketEntityVelocity", "SPacketExplosion", "SPacketHeldItemChange", "SPacketJoinGame", "SPacketKeepAlive", "SPacketMaps", "SPacketMoveVehicle", "SPacketMultiBlockChange", "SPacketOpenWindow", "SPacketParticles", "SPacketPlaceGhostRecipe", "SPacketPlayerAbilities", "SPacketPlayerListHeaderFooter", "SPacketPlayerListItem", "SPacketPlayerPosLook", "SPacketRecipeBook", "SPacketRemoveEntityEffect", "SPacketResourcePackSend", "SPacketRespawn", "SPacketScoreboardObjective", "SPacketSelectAdvancementsTab", "SPacketServerDifficulty", "SPacketSetExperience", "SPacketSetPassengers", "SPacketSetSlot", "SPacketSignEditorOpen", "SPacketSoundEffect", "SPacketSpawnExperienceOrb", "SPacketSpawnGlobalEntity", "SPacketSpawnMob", "SPacketSpawnObject", "SPacketSpawnPainting", "SPacketSpawnPlayer", "SPacketSpawnPosition", "SPacketStatistics", "SPacketTabComplete", "SPacketTeams", "SPacketTimeUpdate", "SPacketTitle", "SPacketUnloadChunk", "SPacketUpdateBossInfo", "SPacketUpdateHealth", "SPacketUpdateScore", "SPacketUpdateTileEntity", "SPacketUseBed", "SPacketWindowItems", "SPacketWindowProperty", "SPacketWorldBorder", "LCPacketEncryptionResponse", "LCPacketLoginStart", "LSPacketDisconnect", "LSPacketEnableCompression", "LSPacketEncryptionRequest", "LSPacketLoginSuccess"].map(function (value) {
            var className = value[0] === "L" ? value.substring(1) : value;
            return {
                name: value,
                staticClass: Java.type("net.minecraft.network.".concat(value[0] === "L" ? "login" : "play", ".").concat(className[0] === "C" ? "client" : "server", ".").concat(className)),
                targetClass: value.indexOf("CPacketPlayer$") !== -1 ? CPacketPlayer.class : value.indexOf("SPacketEntity$") !== -1 ? SPacketEntity.class : null,
                setting: _this.setting.boolean(value, false)
            };
        });
        this.settings = (function () {
            var object = {
                colors: _this.setting.boolean("Colors", true),
                ignoreFields: _this.setting.boolean("IgnoreFields", false)
            };
            for (var _i = 0, _a = _this.packetList; _i < _a.length; _i++) {
                var _b = _a[_i], name_1 = _b.name, setting = _b.setting;
                object[name_1] = setting;
            }
            return object;
        })();
    }
    PacketDebug.prototype.getName = function () {
        return "PacketDebug";
    };
    PacketDebug.prototype.getDescription = function () {
        return "PacketDebug-Module, By-mumy";
    };
    PacketDebug.prototype.getCategory = function () {
        return "Misc";
    };
    PacketDebug.prototype.onPacket = function (event) {
        var packet = event.getPacket().getWrapped();
        for (var _i = 0, _a = this.packetList; _i < _a.length; _i++) {
            var _b = _a[_i], name_2 = _b.name, staticClass = _b.staticClass, targetClass = _b.targetClass, setting = _b.setting;
            if (packet instanceof staticClass) {
                if (setting.get()) {
                    this.printPacket(name_2, targetClass !== null && targetClass !== void 0 ? targetClass : staticClass.class, packet);
                }
                return;
            }
        }
    };
    PacketDebug.prototype.addValues = function (values) {
        for (var _i = 0, _a = Object.keys(this.settings); _i < _a.length; _i++) {
            var key = _a[_i];
            values.add(this.settings[key]);
        }
    };
    PacketDebug.prototype.printPacket = function (name, clazz, packet) {
        var colors = this.settings.colors.get();
        var prefix = "".concat(colors ? "\u00A78[\u00A79".concat(this.getName(), "\u00A78] \u00A73") : "").concat(name);
        if (this.settings.ignoreFields.get()) {
            chat.print("".concat(prefix));
            return;
        }
        var stringJoiner = new StringJoiner(", ");
        var fields = clazz.getDeclaredFields();
        for (var _i = 0, fields_1 = fields; _i < fields_1.length; _i++) {
            var field = fields_1[_i];
            field.setAccessible(true);
            if (Modifier.isStatic(field.getModifiers())) {
                continue;
            }
            var name_3 = Remapper.INSTANCE.remapField(clazz, field.getName());
            var value = field.get(packet);
            stringJoiner.add("".concat(name_3, ": ").concat(value == null ? "null" : value.getClass().isArray() ? Arrays.toString(value) : value.toString()));
        }
        chat.print("".concat(prefix).concat(colors ? "§8" : "", "{ ").concat(colors ? "§7" : "").concat(stringJoiner.toString(), " ").concat(colors ? "§8" : "", "}"));
    };
    return PacketDebug;
}());
var scriptModule;
function onLoad() { }
function onEnable() {
    scriptModule = moduleManager.registerModule(new PacketDebug());
}
function onDisable() {
    moduleManager.unregisterModule(scriptModule);
}