import JavaBoolean = JVM.java$.lang$.Boolean;
import Class = JVM.java$.lang$.Class;
import JavaObject = JVM.java$.lang$.Object;
import JavaString = JVM.java$.lang$.String;
import Modifier = JVM.java$.lang$.reflect$.Modifier;
import Arrays = JVM.java$.util$.Arrays;
import StringJoiner = JVM.java$.util$.StringJoiner;
import PacketEvent = JVM.net$.ccbluex$.liquidbounce$.event$.PacketEvent;
import PacketImpl = JVM.net$.ccbluex$.liquidbounce$.injection$.backend$.PacketImpl;
import Remapper = JVM.net$.ccbluex$.liquidbounce$.script$.remapper$.Remapper;
import BoolValue = JVM.net$.ccbluex$.liquidbounce$.value$.BoolValue;
import INetHandler = JVM.net$.minecraft$.network$.INetHandler;
import Packet = JVM.net$.minecraft$.network$.Packet;
import CPacketPlayer = JVM.net$.minecraft$.network$.play$.client$.CPacketPlayer;
import SPacketEntity = JVM.net$.minecraft$.network$.play$.server$.SPacketEntity;

// CPacketAnimation
// CPacketChatMessage
// CPacketClickWindow
// CPacketClientSettings
// CPacketClientStatus
// CPacketCloseWindow
// CPacketConfirmTeleport
// CPacketConfirmTransaction
// CPacketCreativeInventoryAction
// CPacketCustomPayload
// CPacketEnchantItem
// CPacketEntityAction
// CPacketHeldItemChange
// CPacketInput
// CPacketKeepAlive
// CPacketPlaceRecipe
// CPacketPlayer$Position
// CPacketPlayer$PositionRotation
// CPacketPlayer$Rotation
// CPacketPlayer
// CPacketPlayerAbilities
// CPacketPlayerDigging
// CPacketPlayerTryUseItem
// CPacketPlayerTryUseItemOnBlock
// CPacketRecipeInfo
// CPacketResourcePackStatus
// CPacketSeenAdvancements
// CPacketSpectate
// CPacketSteerBoat
// CPacketTabComplete
// CPacketUpdateSign
// CPacketUseEntity
// CPacketVehicleMove

// SPacketAdvancementInfo
// SPacketAnimation
// SPacketBlockAction
// SPacketBlockBreakAnim
// SPacketBlockChange
// SPacketCamera
// SPacketChangeGameState
// SPacketChat
// SPacketChunkData
// SPacketCloseWindow
// SPacketCollectItem
// SPacketCombatEvent
// SPacketConfirmTransaction
// SPacketCooldown
// SPacketCustomPayload
// SPacketCustomSound
// SPacketDestroyEntities
// SPacketDisconnect
// SPacketDisplayObjective
// SPacketEffect
// SPacketEntity$S15PacketEntityRelMove
// SPacketEntity$S16PacketEntityLook
// SPacketEntity$S17PacketEntityLookMove
// SPacketEntity
// SPacketEntityAttach
// SPacketEntityEffect
// SPacketEntityEquipment
// SPacketEntityHeadLook
// SPacketEntityMetadata
// SPacketEntityProperties
// SPacketEntityStatus
// SPacketEntityTeleport
// SPacketEntityVelocity
// SPacketExplosion
// SPacketHeldItemChange
// SPacketJoinGame
// SPacketKeepAlive
// SPacketMaps
// SPacketMoveVehicle
// SPacketMultiBlockChange
// SPacketOpenWindow
// SPacketParticles
// SPacketPlaceGhostRecipe
// SPacketPlayerAbilities
// SPacketPlayerListHeaderFooter
// SPacketPlayerListItem
// SPacketPlayerPosLook
// SPacketRecipeBook
// SPacketRemoveEntityEffect
// SPacketResourcePackSend
// SPacketRespawn
// SPacketScoreboardObjective
// SPacketSelectAdvancementsTab
// SPacketServerDifficulty
// SPacketSetExperience
// SPacketSetPassengers
// SPacketSetSlot
// SPacketSignEditorOpen
// SPacketSoundEffect
// SPacketSpawnExperienceOrb
// SPacketSpawnGlobalEntity
// SPacketSpawnMob
// SPacketSpawnObject
// SPacketSpawnPainting
// SPacketSpawnPlayer
// SPacketSpawnPosition
// SPacketStatistics
// SPacketTabComplete
// SPacketTeams
// SPacketTimeUpdate
// SPacketTitle
// SPacketUnloadChunk
// SPacketUpdateBossInfo
// SPacketUpdateHealth
// SPacketUpdateScore
// SPacketUpdateTileEntity
// SPacketUseBed
// SPacketWindowItems
// SPacketWindowProperty
// SPacketWorldBorder

// LCPacketEncryptionResponse
// LCPacketLoginStart
// LSPacketDisconnect
// LSPacketEnableCompression
// LSPacketEncryptionRequest
// LSPacketLoginSuccess

const scriptName = "PacketDebug";
const scriptVersion = 0.1;
const scriptAuthor = "mumy++";

class PacketDebug {

    private readonly setting = {
        boolean: (name: string, def: boolean, object: object = {}) => {
            return new _AdaptedValue<boolean, JavaBoolean>(new (Java.extend(BoolValue, object))(name, def));
        }
    };

    private readonly packetList = ["CPacketAnimation", "CPacketChatMessage", "CPacketClickWindow", "CPacketClientSettings", "CPacketClientStatus", "CPacketCloseWindow", "CPacketConfirmTeleport", "CPacketConfirmTransaction", "CPacketCreativeInventoryAction", "CPacketCustomPayload", "CPacketEnchantItem", "CPacketEntityAction", "CPacketHeldItemChange", "CPacketInput", "CPacketKeepAlive", "CPacketPlaceRecipe", "CPacketPlayer$Position", "CPacketPlayer$PositionRotation", "CPacketPlayer$Rotation", "CPacketPlayer", "CPacketPlayerAbilities", "CPacketPlayerDigging", "CPacketPlayerTryUseItem", "CPacketPlayerTryUseItemOnBlock", "CPacketRecipeInfo", "CPacketResourcePackStatus", "CPacketSeenAdvancements", "CPacketSpectate", "CPacketSteerBoat", "CPacketTabComplete", "CPacketUpdateSign", "CPacketUseEntity", "CPacketVehicleMove", "SPacketAdvancementInfo", "SPacketAnimation", "SPacketBlockAction", "SPacketBlockBreakAnim", "SPacketBlockChange", "SPacketCamera", "SPacketChangeGameState", "SPacketChat", "SPacketChunkData", "SPacketCloseWindow", "SPacketCollectItem", "SPacketCombatEvent", "SPacketConfirmTransaction", "SPacketCooldown", "SPacketCustomPayload", "SPacketCustomSound", "SPacketDestroyEntities", "SPacketDisconnect", "SPacketDisplayObjective", "SPacketEffect", "SPacketEntity$S15PacketEntityRelMove", "SPacketEntity$S16PacketEntityLook", "SPacketEntity$S17PacketEntityLookMove", "SPacketEntity", "SPacketEntityAttach", "SPacketEntityEffect", "SPacketEntityEquipment", "SPacketEntityHeadLook", "SPacketEntityMetadata", "SPacketEntityProperties", "SPacketEntityStatus", "SPacketEntityTeleport", "SPacketEntityVelocity", "SPacketExplosion", "SPacketHeldItemChange", "SPacketJoinGame", "SPacketKeepAlive", "SPacketMaps", "SPacketMoveVehicle", "SPacketMultiBlockChange", "SPacketOpenWindow", "SPacketParticles", "SPacketPlaceGhostRecipe", "SPacketPlayerAbilities", "SPacketPlayerListHeaderFooter", "SPacketPlayerListItem", "SPacketPlayerPosLook", "SPacketRecipeBook", "SPacketRemoveEntityEffect", "SPacketResourcePackSend", "SPacketRespawn", "SPacketScoreboardObjective", "SPacketSelectAdvancementsTab", "SPacketServerDifficulty", "SPacketSetExperience", "SPacketSetPassengers", "SPacketSetSlot", "SPacketSignEditorOpen", "SPacketSoundEffect", "SPacketSpawnExperienceOrb", "SPacketSpawnGlobalEntity", "SPacketSpawnMob", "SPacketSpawnObject", "SPacketSpawnPainting", "SPacketSpawnPlayer", "SPacketSpawnPosition", "SPacketStatistics", "SPacketTabComplete", "SPacketTeams", "SPacketTimeUpdate", "SPacketTitle", "SPacketUnloadChunk", "SPacketUpdateBossInfo", "SPacketUpdateHealth", "SPacketUpdateScore", "SPacketUpdateTileEntity", "SPacketUseBed", "SPacketWindowItems", "SPacketWindowProperty", "SPacketWorldBorder", "LCPacketEncryptionResponse", "LCPacketLoginStart", "LSPacketDisconnect", "LSPacketEnableCompression", "LSPacketEncryptionRequest", "LSPacketLoginSuccess"].map((value) => {
        const className = value[0] === "L" ? value.substring(1) : value;
        return {
            name: value,
            staticClass: Java.type(`net.minecraft.network.${value[0] === "L" ? "login" : "play"}.${className[0] === "C" ? "client" : "server"}.${className}`) as typeof Packet<INetHandler>,
            targetClass: value.indexOf("CPacketPlayer$") !== -1 ? CPacketPlayer.class : value.indexOf("SPacketEntity$") !== -1 ? SPacketEntity.class : null,
            setting: this.setting.boolean(value, false)
        };
    });

    private readonly settings = (() => {
        const object: { [key: string]: _AdaptedValue<unknown, unknown> } = {
            colors: this.setting.boolean("Colors", true),
            ignoreFields: this.setting.boolean("IgnoreFields", false)
        };
        for (let { name, setting } of this.packetList) {
            object[name] = setting;
        }
        return object;
    })();

    public getName() {
        return "PacketDebug";
    }

    public getDescription() {
        return "PacketDebug-Module, By-mumy";
    }

    public getCategory() {
        return "Misc";
    }

    public onPacket(event: PacketEvent) {
        const packet = (event.getPacket() as PacketImpl<Packet<INetHandler>>).getWrapped()!;
        for (let { name, staticClass, targetClass, setting } of this.packetList) {
            if (packet instanceof staticClass) {
                if (setting.get()) {
                    this.printPacket(name, targetClass ?? staticClass.class, packet);
                }
                return;
            }
        }
    }

    public addValues(values: _ValueAdapter) {
        for (let key of Object.keys(this.settings)) {
            values.add(this.settings[key as keyof typeof this.settings]);
        }
    }

    private printPacket(name: string, clazz: Class<unknown>, packet: Packet<INetHandler>) {
        const colors = (this.settings.colors as _AdaptedValue<boolean, JavaBoolean>).get();
        const prefix = `${colors ? `§8[§9${this.getName()}§8] §3` : ""}${name}`;
        if ((this.settings.ignoreFields as _AdaptedValue<boolean, JavaBoolean>).get()) {
            chat.print(`${prefix}`);
            return;
        }
        const stringJoiner = new StringJoiner(", ");
        const fields = clazz.getDeclaredFields()!;
        for (let field of fields) {
            field.setAccessible(true);
            if (Modifier.isStatic(field.getModifiers())) {
                continue;
            }
            const name = Remapper.INSTANCE!.remapField(clazz, field.getName());
            const value = field.get(packet) as JavaObject;
            stringJoiner.add(`${name}: ${value == null ? "null" : value.getClass()!.isArray() ? Arrays.toString(value as any) : value.toString()}`);
        }
        chat.print(`${prefix}${colors ? "§8" : ""}{ ${colors ? "§7" : ""}${stringJoiner.toString()} ${colors ? "§8" : ""}}`);
    }

}

let scriptModule: any;

function onLoad() {}

function onEnable() {
    scriptModule = moduleManager.registerModule(new PacketDebug());
}

function onDisable() {
    moduleManager.unregisterModule(scriptModule);
}

